clear, clc, mode(0), close(winsid())
///Optimální řízení s diskrétním modelem $f(y_t|u_t,y_{t-1},\Theta)$



nh=30;                        // interval řízení
y0=1;                         // počáteční podmínky

////Penalizační funkce -- požadavky k řízení
penalization=1;
select penalization
case 1
    ///Nechceme změny na výstupu a vstupu
    om=[10 15;     //u=1, y_{t-1}=1
        15 10;      //u=1, y_{t-1}=2
        20 25;      //u=2, y_{t-1}=1
        25 20];    //u=2, y_{t-1}=2


case 2    
    ///////Chceme změny na výstupu a vstupu    
    om=[25 20;    // u=1, y_{t-1}=1
        20 25;   // u=1, y_{t-1}=2
        15 10;    // u=2, y_{t-1}=1
        10 15];  ///u=2, y_{t-1}=2

case 3  
    ///////Žádné preference 
    om=[3 3;     
        3 3;
        3 3;     
        3 3];

case 4
    //// Náhodné penalizace
    om=floor(10*rand(4,2,'uniform'))+5;       

end
 
 
 
  
//Model - neurčitý
th=[.7 .3;   
    .2 .8;   
    .9 .1;   
    .4 .6];



   
////Model - deterministický
//th=[1 0;   
//    0 1;   
//    1 0;   
//    0 1];

 
 
 
       

// počáteční podmínky
fi=zeros(1,2);

// dynamické programování
for t=nh:-1:1
  fp=om+ones(4,1)*fi;         // penalizační funkce + fi
  
  f=sum((fp.*th),'c');          // střední hodnota přes hodnoty y
  // minimalizace
  if f(1)<f(3),               // pro y(t-1)=1
    uo(t,1)=1; fi(1)=f(1);    // optimální řízení, minimální penalizace
  else 
    uo(t,1)=2; fi(1)=f(3);    // optimální řízení, minimální penalizace
  end
  if f(2)<f(4),               // pro y(t-1)=2
    uo(t,2)=1; fi(2)=f(2);    // optimální řízení, minimální penalizace
  else 
    uo(t,2)=2; fi(2)=f(4);    // optimální řízení, minimální penalizace
  end
end
J=fi(y0);                     // minimální střední hodnota penalizační funkce




// použití optimálního řízení 
y(1)=y0;
for t=1:nh
    u(t+1)=uo(t,y(t));          // optimální řídící vstuo
    j=2*(y(t)-1)+u(t+1); //aktuální číslo řádku z modelu
    y(t+1)=(rand(1,1,'uniform')>th(j,1))+1;//generování výstupu
end









// výsledky
plot(y,'ro','Markersize',10);
plot(u,'g+','Markersize',10);
set(gcf(),"position",[700 100 600 500]);
legend('výstup','řídící vstup');
set(gca(),'data_bounds',[.8 nh+.2, .8 2.2]);
title('Optimální řízení s diskrétním modelem','fontsize',5);
ylabel('Data','fontsize',5);
xlabel('Čas','fontsize',5);

disp('Minimální střední hodnota penalizační funkce',J)
